//import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:reorderables/reorderables.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
//      theme: ThemeData(primarySwatch: Colors.blue),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  static const itemSize = 64.0;
  static const itemCount = 1000;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: PrimaryScrollController(
        controller: ScrollController(initialScrollOffset: itemSize * 500),
        child: Column(
          children: [
            Expanded(
              child: PageView(
                children: [
                  Center(
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: <Widget>[
                        Text('Prescrolled SliverFixedExtentList ->'),
                        Text('(draws instantly)'),
                      ],
                    ),
                  ),
                  CustomScrollView(
                    controller: PrimaryScrollController.of(context),
                    slivers: [
                      SliverFixedExtentList(
                        delegate: SliverChildBuilderDelegate(
                            (c, i) => itemBuilder(c, i),
                          childCount: itemCount,
                        ),
                        itemExtent: itemSize, // <---- this is what needed to skip the lag
                      ),
                    ],
                  ),
                  Center(
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: <Widget>[
                        Text('Prescrolled ReorderableSliverList ->'),
                        Text('(notice the lag)'),
                      ],
                    ),
                  ),
                  CustomScrollView(
                    controller: PrimaryScrollController.of(context),
                    slivers: [
                      ReorderableSliverList(
                        delegate: ReorderableSliverChildBuilderDelegate(
                            (c, i) => itemBuilder(c, i),
                          childCount: itemCount,
                        ),
                        onReorder: (i, j) {},
                        //itemExtent: itemSize, <--- is really needed
                      ),
                    ],
                  ),
                  //Text('Native ReorderableListView which sucks ->'),
                  //ReorderableListView(
                  //  children: List.generate(itemCount, (i) => itemBuilder(context, i)),
                  //  onReorder: (i, j) {},
                  //)
                ],
              ),
            )
          ],
        ),
      ),
    );
  }

  Widget itemBuilder(BuildContext context, int index) {
    return Container(
      key: Key(index.toString()),
      height: itemSize,
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          Padding(
            padding: EdgeInsets.all(8),
            child: Stack(
              children: [
                ClipRRect(
                  borderRadius: BorderRadius.circular(5),
                  child: Container(
                    height: 48,
                    width: 48,
                    color: Colors.blueAccent,
                  ),
                ),
                Positioned.fill(
                  child: Center(
                    child: Text(
                      index.toString(),
                      style: TextStyle(color: Colors.white, fontSize: 18),
                    ),
                  ),
                )
              ],
            ),
          ),
          Text(
            'List item #$index text',
            style: TextStyle(fontSize: 16),
          ),
        ],
      ),
    );
  }
}